from PyQt4.Qt import pyqtSignal
from _Containable    import Containable
class Character(Containable):
  broadcast = pyqtSignal(str)
  def tick(self):
    def getcmd(c):
      x =  c.getfirst()
      return x[0], x[1:]
    c = self.commands
    if c.len:
      obj,cmd = getcmd(c)
      while obj != self:
        obj.commands.add(c.pop())
        obj,cmd = getcmd(c)
      x,y = self.position
      self.broadcast.emit("%s@%s:\t%s"%(self.name, self.position,`cmd`))
      if cmd[0] == 'up':
        self.position = (x,y-1)
        c.pop()
      elif cmd[0] == 'down':
        self.position = (x,y+1)
        c.pop()
      elif cmd[0] == 'left':
        self.position = (x-1,y)
        c.pop()
      elif cmd[0] == 'right':
        self.position = (x+1,y)
        c.pop()
      elif cmd[0] in ['move', 'attack']:
        X,Y = cmd[1]
        if X-x > 0:
          self.position = (x+1,y)
        elif X-x < 0:
          self.position = (x-1,y)
        elif Y-y > 0:
          self.position = (x,y+1)
        elif Y-y < 0:
          self.position = (x,y-1)
        if (X-x)**2 + (Y-y)**2 == 1:
          c.pop()
      self._allObjects[0].Changed.emit()

  def __init__(self, **kwargs):
    if not 'name' in kwargs:
      kwargs['name'] = 'Unknown Character'
    Containable.__init__(self, **kwargs)