from PyQt4.Qt import (QObject,
                      pyqtSignal,
                      QString)
from _fifo import _fifo
class commandQueue(QObject):
  addedTo = pyqtSignal(tuple)
  takenFrom = pyqtSignal(tuple)
  isNotEmpty = pyqtSignal()
  isEmpty = pyqtSignal()
  def add(self, *item):
    self._fifo.append(tuple(item))
  def __init__(self):
    QObject.__init__(self)
    self._fifo = _fifo(self)
    self.first = self._fifo.first
    self.getfirst = self._fifo.getfirst
    self.pop = self._fifo.pop
    self.isEmpty.emit()
  @property
  def len(self):
    return len(self._fifo._list)