from PyQt4.Qt import QTextEdit, QString
class DebugOutput(QTextEdit):
  def __init__(self, player, parent, *args, **kwargs):
    QTextEdit.__init__(self, *args, **kwargs)
    QTextEdit.setFontPointSize(self, 10)
    self.setFixedWidth(320)
    self.setReadOnly(True)
    x = self.property("kineticScroller").toPyObject()
    if x:
      x.setEnabled(True)
    del x
    self.text = ''
    self.parent = parent
    self.player = player
    player.commands.addedTo.connect(self._append)
    player.broadcast.connect(self._append)
  def _append(self,line):
    self.append(str(line))
    #anchor = QString(line)
    #self.text += '\n'+line
    #QTextEdit.setText(self,self.text)
    #self.scrollContentsBy(0,-self.rect().height())

  def resizeEvent(self, event):
    rect = self.rect()
    # self.append( 'Debug output:\t' +
                 # `rect.width()` +
                 # "x" +
                 # `rect.height()`)
    QTextEdit.resizeEvent(self, event)
  def paintEvent(self, event):
    QTextEdit.paintEvent(self, event)
