from PyQt4.Qt       import QMainWindow, QTimer
class DisplayObject(QMainWindow):
  def doTicks(s):
    for char in s.Game.Player.getAllSameClass():
      char.tick()
  def exec_(s):
    s._a.exec_()
  def __init__(s, Game):
    from _DebugOutput   import DebugOutput
    from _DisplayWindow import DisplayWindow
    from _Interface     import Interface
    from PyQt4.Qt import QApplication, QWidget, QGridLayout, QIcon
    from sys import argv
    import os.path
    win = (800, 480)
    s.Game = Game
    a = QApplication(argv)        # We'll need a QApplication.
    QMainWindow.__init__(s)       # And it'll be a subclass of QMainWindow,
    s.resize(*win)                # so initialise it and give it a size.
    central = QWidget()
    s.setCentralWidget(central)   # Central widget to contain layout,
    s.grid = QGridLayout(central) # like so...
    s.setWindowTitle("pyRPG")     # Let's give it a nice title.
    s._a = a
    s.commands = Game.commands
    iconpath = ("Display/pyrpg.png")
    s.icon_ = QIcon()
    s.icon_.addFile(iconpath)
    s.setWindowIcon(s.icon_)

    s.DebugOutput = DebugOutput(player=Game.Player,parent=s)
    s.MainGraphicView = DisplayWindow(player=Game.Player,textstream=s.DebugOutput)
    s.Options = Interface(player=Game.Player,parent=s,textstream=s.DebugOutput)
    
    s.grid.addWidget(s.MainGraphicView, 0, 0)
    s.grid.addWidget(s.Options, 1, 0, 1, 0)
    s.grid.addWidget(s.DebugOutput, 0, 1)

    s.grid.setMargin(0)
    s.grid.setSpacing(0)
    s.grid.setRowStretch (0, 400)
    s.grid.setRowStretch (1, 80)
    s.grid.setColumnStretch (0, 480)
    s.grid.setColumnStretch (1, 320)
    
    s.Timer = QTimer()
    s.Timer.start(200)
    s.Timer.timeout.connect(s.doTicks)
    s.Game.Changed.connect(s.MainGraphicView.update)

    s.showFullScreen()            # There's no point doing all of this if we
                                  # don't show it(FullScreen?)
