from PyQt4.QtGui import QPushButton, QBrush, QIcon
from PyQt4.QtCore import Qt, QRect

class clickableIcon(QPushButton):
  def paintEvent(self, event):
    r = QRect(self.x, self.y, self.w, self.h)
    self.image.paint(self.qp, r)
  def setRect(self,x,y,w,h):
    r = self.rect()
    self.x = x
    self.y = y
    self.w = w
    self.h = h
    r.setRect(x,y,w,h)
    self.setGeometry(r)
  def centre(self):
    r = self.rect()
    return (r.x()+r.width()/2, r.y()+r.height()/2)
  def __init__(self,parent,image):
    QPushButton.__init__(self)
    self.image = QIcon()
    self.qp = parent.qp
    self.x = 0
    self.y = 0
    self.w = 0
    self.h = 0
    self.imagename = "_Display/Sprites/"+image+".png"
    self.image.addFile(self.imagename)
    #self.move(x,y) translates the sprite's rectangle