from PyQt4.QtGui import (QColor,
                         QPainter,
                         QIcon,
                         QImage,
                         QBrush,
                         QPushButton,
                         QLabel,
                         QSizePolicy,
                         QKeySequence)
from PyQt4.QtCore import (QString,
                          QSize,
                          Qt)
import os.path
class interfaceButton(QPushButton):
  def paintEvent_(self, event):
    black = QColor("#000000")
    charcoal = QColor("#101010")
    orange = QColor("#F08038")
    if self.isDown() or (self.isChecked() and self.isCheckable()):
      background = orange
    else:
      background = black
    brush = QBrush(Qt.SolidPattern)
    self.qp.begin(self)
    self.qp.setBrush(brush)
    self.qp.fillRect(self.rect(), background)
    self.image.paint(self.qp, self.rect(), state=QIcon.On)
    self.qp.end()
  def paintEvent__(self, event):
    QPushButton.paintEvent(self, event)
    pass
  def __init__(self, parent, display='', shortcut=None):
    QPushButton.__init__(self)
    self.parent = parent
    self.setSizePolicy(QSizePolicy.MinimumExpanding, QSizePolicy.MinimumExpanding)
    try:
      assert os.path.isfile(display)
      self.imagename = display
      self.image = QIcon()
      self.image.addFile(display)
      self.image.sizeHint = self.sizeHint
      self.qp = parent.qp
      self.paintEvent = self.paintEvent_
      self.setFlat(True)
    except:
      self.setText(display)
      if display=='':
        self.setFlat(True)
      self.paintEvent = self.paintEvent__
    if shortcut:
      self.setShortcut(QKeySequence(shortcut))